import MuseScore 3.0
import QtQuick 2.1
import QtQuick.Controls 2.1
import QtQuick.Layouts 1.2

 MuseScore {
  version: "1.0"
  id: window
  menuPath: "Plugins.MS3MenuName"  
  description: "My Description-a"

  requiresScore: false
  pluginType: "dialog"
 
  width: 200
  height: 300
  visible: true
  
  property int globalVariable: 10
  property var globalVar: 5
  
 Component.onCompleted: {  // optional for 4.2, but useful to test in all versions
       console.log ("plugin loading completed");
        if (mscoreMajorVersion >= 4) {
        if (mscoreMinorVersion >= 4) {
            // VERY STRICT syntax: "title:", with no space between 'title' and ':'
           title: "Title for MS4.4+ "
        } else {
           var tString = "Title for MS4.0 to 4.3x " 
          title=qsTr(tString);
          }
      } else {
      }
 }
  
   
  function myFun(a,b) {
    return (a+b)
  }
 
  onRun:{
    // console log doesn't show in the application, only on the terminal when
    // using -d option.
    console.log ("We're running");
    globalVar = globalVar + "A";
    globalVariable += 3;
    myFun (1,3); // Oh, didn't look at return value
    console.log ("myFun test #1: " + myFun(11,43));
    console.log ("myFun test #2: " + myFun("AB","CD"));
    for (var i = 1; i < 4; i++) {
      console.log ("var i is: " + i);
    }
  }
  
  Column {
  Text {
     id: refText;
     font.pixelSize: 14                
     text: "hello world!";
  }
  
  Button {
    id: button4Text;
    text: 'Add text'
    visible: true
    onClicked: { 
        refText.text = "goodbye!"            
    }
  }
  Button {
    id: button4Number;
    text: 'Show number +1'
    visible: true
    onClicked: { 
       globalVariable += 1;
       refText.text = globalVariable;
    }
  }
  Button {
    id: button4TShowHide;
    text: 'Hide/Show buttons'
    visible: true
    onClicked: { 
          button4Text.visible = !button4Text.visible;
          button4Number.visible = !button4Number.visible;
    }
  }
  Button {
    text: 'close';
    visible: true;
    onClicked: {
      (typeof(quit)==='undefined' ? Qt.quit(): quit());
    }
  }       
  }   
} // end MuseScore
